<?php

namespace PME\Auth\Exception;

class AccessException extends \Exception {
    protected $variables;

    protected const ACESS_DENIED_STATUS         = 403;
    protected const DEFAULT_EXCEPTION_MESSAGE   = 'Acesso negado. Verifique se você possui acesso a esse recurso específico.';
    protected const INVALID_TOKEN_MESSAGE       = 'Acesso inválido. Verifique se você possui acesso a esse recurso específico.';
    protected const EXPIRED_TOKEN_MESSAGE       = 'Acesso expirado. Verifique se você possui acesso a esse recurso específico.';
    
    public function __construct($message = self::DEFAULT_EXCEPTION_MESSAGE, $code = self::ACESS_DENIED_STATUS, Exception $previous = null) {
        parent::__construct($message, $code, $previous);
    }

    public static function invalidToken() {
        throw new AccessException(self::INVALID_TOKEN_MESSAGE);
    }

    public static function expiredToken() {
        throw new AccessException(self::EXPIRED_TOKEN_MESSAGE);
    }
}

