<?php
namespace Estoque\Repositories;

/**
 *
 */
class Lanctoestoq extends \Doctrine\ORM\EntityRepository
{

    /**
     * Verifica o volume de entradas.
     *
     * @param $cdfilirece
     * @param \DateTime $dataEntradaNf
     *
     * @return float
     *
     * @throws \Exception
     */
    public function verificarVolumeEntradas($cdfilirece, \DateTime $dataEntradaNf)
    {
        $dtinicial = \Geral\Util\DateUtil::getPrimeiroDiaDoMes($dataEntradaNf);
        $dtfinal   = \Geral\Util\DateUtil::getUltimoDiaDoMes($dataEntradaNf);

        $idevolestoq            = \Estoque\Entities\Itlanctoest::ESTOQUE_EVOLUIDO;
        $tplancEntradaDeEstoque = \Estoque\Entities\Lanctoestoq::LANCAMENTO_ENTRADA_NO_ESTOQUE;
        $tplancDocumentoEntrada = \Estoque\Entities\Lanctoestoq::LANCAMENTO_DOC_FISCAL_DE_ENTRADA;

        $sql = "SELECT SUM(VRTOTLANCTO) VRTOTALENTR
                  FROM LANCTOESTOQ L, ITLANCTOEST I
                  WHERE L.CDFILIMOVI = '$cdfilirece'
                    AND L.DTLANCESTQ BETWEEN '$dtinicial' AND '$dtfinal'
                    AND L.CDFILIAL   = I.CDFILIAL
                    AND L.NRLANCESTQ = I.NRLANCESTQ
                    AND L.IDTPLANCTO IN ('$tplancEntradaDeEstoque','$tplancDocumentoEntrada')
                    AND NVL(I.IDEVOLESTOQ, '$idevolestoq') = '$idevolestoq'";

        try {
            return (float)$this->getEntityManager()->getConnection()->fetchColumn($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}