/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3930_CDPSTPO.SQL

Descrio:
Calcula periodicidade de produo para dias do ms.

P_CDFILIAL     - Cdigo da Filial.
P_CDPERIPRODU  - Cdigo da Periodicidade de Produo.
P_DTINICIAL    - Data inicial a ser gerado o clculo.
P_IDDIANUTIL   - Indicador de utilizao de dia no til para produo.
P_DTPROCESSA   - Data de Processamento da Filial.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
08/09/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'PERIPRODUCAO_MENSAL' AND type = 'P')
   DROP PROCEDURE PERIPRODUCAO_MENSAL
   GO

CREATE PROCEDURE PERIPRODUCAO_MENSAL
   @P_CDFILIAL        VARCHAR(4),
   @P_CDPERIPRODU     VARCHAR(2),
   @P_DTINICIAL       DATETIME,
   @P_IDDIANUTIL      VARCHAR(1),
   @P_DTPROCESSA      DATETIME
AS
   DECLARE @V_CONTAUXI    NUMERIC;
   DECLARE @V_DIPRODUCAO  VARCHAR(2);
   DECLARE @V_DTDIAPRODU  DATETIME;
BEGIN
   SET @V_CONTAUXI = 0;

/*-------- CURSOR QUE CONTEM TODOS OS DIAS DE ENTREGA DE DETERMINADA PERIODICIDADE ------*/
   DECLARE C_DIAS_PRODU CURSOR FOR
      SELECT
         DIPRODUCAO
      FROM
         DIASPRODUCAO
      WHERE
         CDPERIPRODU = @P_CDPERIPRODU
      ORDER BY
         DIPRODUCAO;

   OPEN C_DIAS_PRODU;
   FETCH NEXT FROM C_DIAS_PRODU INTO @V_DIPRODUCAO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_DTDIAPRODU = (CONVERT(INT,@P_DTINICIAL) - 1) + @V_DIPRODUCAO;
      IF (@V_DTDIAPRODU > (DATEADD(MM, 1, @P_DTINICIAL) - DAY(DATEADD(MM, 1, @P_DTINICIAL)))) BEGIN
         SET @V_DTDIAPRODU = (DATEADD(MM, 1, @P_DTINICIAL) - DAY(DATEADD(MM, 1, @P_DTINICIAL)));
      END;

      IF @V_DTDIAPRODU >= @P_DTPROCESSA BEGIN

         SELECT
            @V_CONTAUXI = COUNT(*)
         FROM
            FERICOMP
         WHERE
            CDFILIAL   = @P_CDFILIAL    AND
            DTFERICOMP = @V_DTDIAPRODU;

         IF ((@P_IDDIANUTIL = 'S') AND (@V_CONTAUXI = 0)) OR
            (@P_IDDIANUTIL = 'N')                        BEGIN
             /*- INCLUI A DATA DE PRODUCAO CALCULADA NO CALENDARIO DE PRODUCAO -*/
            INSERT INTO CALEPRODUCAO
               (CDFILIAL,
                CDPERIPRODU,
                DTPRODUCAO)
            VALUES
               (@P_CDFILIAL,
                @P_CDPERIPRODU,
                @V_DTDIAPRODU);
         END;
      END;
      FETCH NEXT FROM C_DIAS_PRODU INTO @V_DIPRODUCAO;
   END;
   CLOSE C_DIAS_PRODU;
   DEALLOCATE C_DIAS_PRODU;
END
GO