IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_CMP_ITEMSOLI' AND
                 TYPE = 'TR'         AND
                  U.UID = O.UID             AND
                  U.NAME = USER)
DROP TRIGGER LOG_CMP_ITEMSOLI
GO

CREATE  TRIGGER LOG_CMP_ITEMSOLI
ON ITEMSOLI
FOR INSERT, UPDATE

AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(80);
   DECLARE  @V_DESC      VARCHAR(1500);
   DECLARE  @V_DTOPER    DATETIME;
   DECLARE  @V_IDPARAM   VARCHAR(1);

      /*VARIVEIS DO CURSOR C_CURSORITEMSOLI*/
   DECLARE @V_ID_COMANDO        VARCHAR(1);

   DECLARE @V_OLD_CDFILSOLI     VARCHAR(4);
   DECLARE @V_OLD_CDFILLAN      VARCHAR(4);
   DECLARE @V_OLD_NRSOLICMP     VARCHAR(10);
   DECLARE @V_OLD_CDPRODUTO     VARCHAR(10);
   DECLARE @V_OLD_DTPROGENTR    DATETIME;
   DECLARE @V_OLD_CDOPERAPROV   VARCHAR(12);
   DECLARE @V_OLD_DTUTILIZA     DATETIME;
   DECLARE @V_OLD_QTSOLIPROD    FLOAT;
   DECLARE @V_OLD_IDITMCONS     VARCHAR(1);
   DECLARE @V_OLD_IDSOLIAPROV   VARCHAR(1);
   DECLARE @V_OLD_DTHRAPROVSOL  DATETIME;
   DECLARE @V_OLD_CDFILIOPELOG  VARCHAR(4);
   DECLARE @V_OLD_NRSEQUCONSOL  VARCHAR(10);
   DECLARE @V_OLD_IDPEDIDOOL    VARCHAR(1);

   DECLARE @V_NEW_CDFILSOLI     VARCHAR(4);
   DECLARE @V_NEW_CDFILLAN      VARCHAR(4);
   DECLARE @V_NEW_NRSOLICMP     VARCHAR(10);
   DECLARE @V_NEW_CDPRODUTO     VARCHAR(10);
   DECLARE @V_NEW_DTPROGENTR    DATETIME;
   DECLARE @V_NEW_CDOPERAPROV   VARCHAR(12);
   DECLARE @V_NEW_DTUTILIZA     DATETIME;
   DECLARE @V_NEW_QTSOLIPROD    FLOAT;
   DECLARE @V_NEW_IDITMCONS     VARCHAR(1);
   DECLARE @V_NEW_IDSOLIAPROV   VARCHAR(1);
   DECLARE @V_NEW_DTHRAPROVSOL  DATETIME;
   DECLARE @V_NEW_CDFILIOPELOG  VARCHAR(4);
   DECLARE @V_NEW_NRSEQUCONSOL  VARCHAR(10);
   DECLARE @V_NEW_IDPEDIDOOL    VARCHAR(1);

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSORITEMSOLI CURSOR FOR
      SELECT
             'D' IDCOMANDO,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              DELETED.CDFILSOLI,
              DELETED.CDFILLAN,
              DELETED.NRSOLICMP,
              DELETED.CDPRODUTO,
              DELETED.DTPROGENTR,
              DELETED.CDOPERAPROV,
              DELETED.DTUTILIZA,
              DELETED.QTSOLIPROD,
              DELETED.IDITMCONS,
              DELETED.IDSOLIAPROV,
              DELETED.DTHRAPROVSOL,
              DELETED.CDFILIOPELOG,
              DELETED.NRSEQUCONSOL,
              DELETED.IDPEDIDOOL
      FROM
         DELETED
       WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
            'U' IDCOMANDO,
             INSERTED.CDFILSOLI,
             INSERTED.CDFILLAN,
             INSERTED.NRSOLICMP,
             INSERTED.CDPRODUTO,
             INSERTED.DTPROGENTR,
             INSERTED.CDOPERAPROV,
             INSERTED.DTUTILIZA,
             INSERTED.QTSOLIPROD,
             INSERTED.IDITMCONS,
             INSERTED.IDSOLIAPROV,
             INSERTED.DTHRAPROVSOL,
             INSERTED.CDFILIOPELOG,
             INSERTED.NRSEQUCONSOL,
             INSERTED.IDPEDIDOOL,
             DELETED.CDFILSOLI,
             DELETED.CDFILLAN,
             DELETED.NRSOLICMP,
             DELETED.CDPRODUTO,
             DELETED.DTPROGENTR,
             DELETED.CDOPERAPROV,
             DELETED.DTUTILIZA,
             DELETED.QTSOLIPROD,
             DELETED.IDITMCONS,
             DELETED.IDSOLIAPROV,
             DELETED.DTHRAPROVSOL,
             DELETED.CDFILIOPELOG,
             DELETED.NRSEQUCONSOL,
             DELETED.IDPEDIDOOL
        FROM
             INSERTED,
             DELETED
       WHERE
             INSERTED.CDFILSOLI    =  DELETED.CDFILSOLI   AND
             INSERTED.CDFILLAN     =  DELETED.CDFILLAN    AND
             INSERTED.NRSOLICMP    =  DELETED.NRSOLICMP   AND
             INSERTED.CDPRODUTO    =  DELETED.CDPRODUTO   AND
             INSERTED.DTPROGENTR   =  DELETED.DTPROGENTR  AND
             INSERTED.QTSOLIPROD   =  DELETED.QTSOLIPROD

      UNION ALL

      SELECT
             'I' IDCOMANDO,
             INSERTED.CDFILSOLI,
             INSERTED.CDFILLAN,
             INSERTED.NRSOLICMP,
             INSERTED.CDPRODUTO,
             INSERTED.DTPROGENTR,
             INSERTED.CDOPERAPROV,
             INSERTED.DTUTILIZA,
             INSERTED.QTSOLIPROD,
             INSERTED.IDITMCONS,
             INSERTED.IDSOLIAPROV,
             INSERTED.DTHRAPROVSOL,
             INSERTED.CDFILIOPELOG,
             INSERTED.NRSEQUCONSOL,
             INSERTED.IDPEDIDOOL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSORITEMSOLI;
   FETCH NEXT FROM C_CURSORITEMSOLI INTO @V_ID_COMANDO,
                                 @V_NEW_CDFILSOLI,
                                 @V_NEW_CDFILLAN,
                                 @V_NEW_NRSOLICMP,
                                 @V_NEW_CDPRODUTO,
                                 @V_NEW_DTPROGENTR,
                                 @V_NEW_CDOPERAPROV,
                                 @V_NEW_DTUTILIZA,
                                 @V_NEW_QTSOLIPROD,
                                 @V_NEW_IDITMCONS,
                                 @V_NEW_IDSOLIAPROV,
                                 @V_NEW_DTHRAPROVSOL,
                                 @V_NEW_CDFILIOPELOG,
                                 @V_NEW_NRSEQUCONSOL,
                                 @V_NEW_IDPEDIDOOL,
                                 @V_OLD_CDFILSOLI,
                                 @V_OLD_CDFILLAN,
                                 @V_OLD_NRSOLICMP,
                                 @V_OLD_CDPRODUTO,
                                 @V_OLD_DTPROGENTR,
                                 @V_OLD_CDOPERAPROV,
                                 @V_OLD_DTUTILIZA,
                                 @V_OLD_QTSOLIPROD,
                                 @V_OLD_IDITMCONS,
                                 @V_OLD_IDSOLIAPROV,
                                 @V_OLD_DTHRAPROVSOL,
                                 @V_OLD_CDFILIOPELOG,
                                 @V_OLD_NRSEQUCONSOL,
                                 @V_OLD_IDPEDIDOOL;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_IDPARAM = ISNULL(MAX(IDUTAPROVSOL), 'N')
        FROM PARCMPSUP
       WHERE CDFILIAL = ISNULL(@V_NEW_CDFILSOLI, @V_OLD_CDFILSOLI);

      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (ISNULL(@V_OLD_CDFILSOLI, '')     <>     ISNULL(@V_NEW_CDFILSOLI, ''))   OR
            (ISNULL(@V_OLD_CDFILLAN,'')       <>     ISNULL(@V_NEW_CDFILLAN,''))     OR
            (ISNULL(@V_OLD_NRSOLICMP,'')      <>     ISNULL(@V_NEW_NRSOLICMP,''))    OR
            (ISNULL(@V_OLD_CDPRODUTO,'')      <>     ISNULL(@V_NEW_CDPRODUTO,''))    OR
            (ISNULL(@V_OLD_DTPROGENTR,0)      <>     ISNULL(@V_NEW_DTPROGENTR,0))    OR
            (ISNULL(@V_OLD_CDOPERAPROV,'')    <>     ISNULL(@V_NEW_CDOPERAPROV,''))  OR
            (ISNULL(@V_OLD_DTUTILIZA,0)       <>     ISNULL(@V_NEW_DTUTILIZA,0))     OR
            (ISNULL(@V_OLD_QTSOLIPROD,0)      <>     ISNULL(@V_NEW_QTSOLIPROD,0))    OR
            (ISNULL(@V_OLD_IDITMCONS,'')      <>     ISNULL(@V_NEW_IDITMCONS,''))    OR
            (ISNULL(@V_OLD_IDSOLIAPROV,'')    <>     ISNULL(@V_NEW_IDSOLIAPROV,''))  OR
            (ISNULL(@V_OLD_DTHRAPROVSOL,0)    <>     ISNULL(@V_NEW_DTHRAPROVSOL,0))  OR
            (ISNULL(@V_OLD_CDFILIOPELOG,'')   <>     ISNULL(@V_NEW_CDFILIOPELOG,'')) OR
            (ISNULL(@V_OLD_NRSEQUCONSOL,'')   <>     ISNULL(@V_NEW_NRSEQUCONSOL,'')) OR
            (ISNULL(@V_OLD_IDPEDIDOOL,'')     <>     ISNULL(@V_NEW_IDPEDIDOOL,'')) BEGIN

            IF ISNULL(@V_OLD_DTPROGENTR, '') <> ISNULL(@V_NEW_DTPROGENTR, 0) BEGIN
               IF @V_NEW_DTPROGENTR IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Entr. Item'  + CONVERT(VARCHAR, @V_NEW_DTPROGENTR) + ' ';
               END;
            END;
            IF ISNULL(@V_OLD_CDOPERAPROV, 'X') <> ISNULL(@V_NEW_CDOPERAPROV, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'Oper. Aprova.'  + @V_NEW_CDOPERAPROV + ' ';
            END;
            IF ISNULL(@V_OLD_DTUTILIZA, '') <> ISNULL(@V_NEW_DTUTILIZA, 0) BEGIN
               IF @V_NEW_DTUTILIZA IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Ut.'  + CONVERT(VARCHAR, @V_NEW_DTUTILIZA) + ' ';
               END;   
            END;
            IF ISNULL(@V_OLD_QTSOLIPROD, 0) <> ISNULL(@V_NEW_QTSOLIPROD, 0) BEGIN
                  SET @V_DESC = @V_DESC + 'Qt. Itens:'  + CONVERT(VARCHAR, @V_NEW_QTSOLIPROD) + ' ';
            END;
            IF ISNULL(@V_OLD_IDITMCONS, 'X') <> ISNULL(@V_NEW_IDITMCONS, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'ID Cons:'  + @V_NEW_IDITMCONS + ' ';
            END;
            IF ISNULL(@V_OLD_IDSOLIAPROV, 'X') <> ISNULL(@V_NEW_IDSOLIAPROV, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'ID Aprovao:'  + @V_NEW_IDSOLIAPROV + ' ';
            END;
            IF ISNULL(@V_OLD_DTHRAPROVSOL, '') <> ISNULL(@V_NEW_DTHRAPROVSOL, '') BEGIN
               IF @V_NEW_DTHRAPROVSOL IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Aprovao:'  + CONVERT(VARCHAR, @V_NEW_DTHRAPROVSOL) + ' ';
               END;
            END;
            IF ISNULL(@V_OLD_CDFILIOPELOG, 'X') <> ISNULL(@V_NEW_CDFILIOPELOG, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'Filial OL:'  + @V_NEW_CDFILIOPELOG + ' ';
            END;
            IF ISNULL(@V_OLD_NRSEQUCONSOL, 'X') <> ISNULL(@V_NEW_NRSEQUCONSOL, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'Consolidao:'  + @V_NEW_NRSEQUCONSOL + ' ';
            END;
            IF ISNULL(@V_IDPARAM, 'X') <> ISNULL(@V_IDPARAM, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'Param. Aprova:'  + @V_IDPARAM + ' ';
            END;
            IF ISNULL(@V_OLD_IDPEDIDOOL, 'X') <> ISNULL(@V_NEW_IDPEDIDOOL, 'X') BEGIN
                  SET @V_DESC = @V_DESC + 'Gerou Pedido:'  + @V_NEW_IDPEDIDOOL + ' ';
            END;

            SET  @V_TIPO   = '2';
            SET  @V_ITPESQ = @V_ID_COMANDO + @V_NEW_CDFILSOLI + @V_NEW_CDFILLAN + @V_NEW_NRSOLICMP + @V_NEW_CDPRODUTO + CONVERT(VARCHAR, @V_NEW_DTPROGENTR, 8);
         END;
      END
      ELSE BEGIN
         IF @V_NEW_CDFILSOLI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial Dest.'  + @V_NEW_CDFILSOLI + ' ';
         END;
         IF @V_NEW_CDFILLAN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial Lan.'  + @V_NEW_CDFILLAN + ' ';
         END;
         IF @V_NEW_NRSOLICMP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nmero'  + @V_NEW_NRSOLICMP + ' ';
         END;
         IF @V_NEW_CDPRODUTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Produto'  + @V_NEW_CDPRODUTO + ' ';
         END;
         IF @V_NEW_DTPROGENTR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Entr. Item'  + CONVERT(VARCHAR, @V_NEW_DTPROGENTR) + ' ';
         END;
         IF @V_NEW_CDOPERAPROV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Oper. Aprova.'  + @V_NEW_CDOPERAPROV + ' ';
         END;
         IF @V_NEW_DTUTILIZA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Ut.'  + CONVERT(VARCHAR, @V_NEW_DTUTILIZA) + ' ';
         END;
         IF @V_NEW_QTSOLIPROD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Qt. Itens:'  + CONVERT(VARCHAR, @V_NEW_QTSOLIPROD) + ' ';
         END;
         IF @V_NEW_IDITMCONS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ID Cons:'  + @V_NEW_IDITMCONS + ' ';
         END;
         IF @V_NEW_IDSOLIAPROV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ID Aprovao:'  + @V_NEW_IDSOLIAPROV + ' ';
         END;
         IF @V_NEW_DTHRAPROVSOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Aprovao:'  + CONVERT(VARCHAR, @V_NEW_DTHRAPROVSOL) + ' ';
         END;
         IF @V_NEW_CDFILIOPELOG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial OL:'  + @V_NEW_CDFILIOPELOG + ' ';
         END;
         IF @V_NEW_NRSEQUCONSOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Consolidao:'  + @V_NEW_NRSEQUCONSOL + ' ';
         END;
         IF @V_IDPARAM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Param. Aprova:'  + @V_IDPARAM + ' ';
         END;
         IF @V_NEW_IDPEDIDOOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Gerou Pedido:'  + @V_NEW_IDPEDIDOOL + ' ';
         END;

         SET  @V_TIPO   = '1';
         SET  @V_ITPESQ = @V_ID_COMANDO + @V_NEW_CDFILSOLI + @V_NEW_CDFILLAN + @V_NEW_NRSOLICMP + @V_NEW_CDPRODUTO + CONVERT(VARCHAR, @V_NEW_DTPROGENTR, 8);
      END;
      EXEC NMUSUARIO @V_USUARIO;
      SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
      IF (@V_TIPO <> '0')  BEGIN
         IF @V_DESC IS NOT NULL BEGIN
            IF @V_USUARIO IS NOT NULL BEGIN
               SET  @V_DTOPER = GETDATE();
               SET  @V_DESC = SUBSTRING(@V_DESC, 1, 300);
                  INSERT INTO LOGOPERA
                             (NMTABELA, DTOPERACAO, NMRESPOPER,
                              IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
                         VALUES
                             ('ITEMSOLI', @V_DTOPER, @V_USUARIO,
                              @V_TIPO, @V_ITPESQ, @V_DESC, @V_NEW_CDFILLAN);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSORITEMSOLI INTO @V_ID_COMANDO,
                                    @V_NEW_CDFILSOLI,
                                    @V_NEW_CDFILLAN,
                                    @V_NEW_NRSOLICMP,
                                    @V_NEW_CDPRODUTO,
                                    @V_NEW_DTPROGENTR,
                                    @V_NEW_CDOPERAPROV,
                                    @V_NEW_DTUTILIZA,
                                    @V_NEW_QTSOLIPROD,
                                    @V_NEW_IDITMCONS,
                                    @V_NEW_IDSOLIAPROV,
                                    @V_NEW_DTHRAPROVSOL,
                                    @V_NEW_CDFILIOPELOG,
                                    @V_NEW_NRSEQUCONSOL,
                                    @V_NEW_IDPEDIDOOL,
                                    @V_OLD_CDFILSOLI,
                                    @V_OLD_CDFILLAN,
                                    @V_OLD_NRSOLICMP,
                                    @V_OLD_CDPRODUTO,
                                    @V_OLD_DTPROGENTR,
                                    @V_OLD_CDOPERAPROV,
                                    @V_OLD_DTUTILIZA,
                                    @V_OLD_QTSOLIPROD,
                                    @V_OLD_IDITMCONS,
                                    @V_OLD_IDSOLIAPROV,
                                    @V_OLD_DTHRAPROVSOL,
                                    @V_OLD_CDFILIOPELOG,
                                    @V_OLD_NRSEQUCONSOL,
                                    @V_OLD_IDPEDIDOOL;

   END;
   CLOSE      C_CURSORITEMSOLI;
   DEALLOCATE C_CURSORITEMSOLI;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CMP_ITEMSOLI','5.65.XXX';
GO