import { Http, IDictionary } from '@zeedhi/core';

export class CrudController {
  private setProperties(rows: IDictionary) {
    rows.forEach((row: IDictionary) => {
      if (!row.__is_new) row.__is_new = false;
    });
    
    return rows;
  }
  
  public async deleteRows(checkedRows: IDictionary, dataSourceName: string) {
    return Http.post('/crud/delete', { checkedRows, dataSourceName });
  }

  public async saveRows(rows: IDictionary, dataSourceName: string) {
    const editedRows = this.setProperties(rows);
    return Http.post('/crud/save', { editedRows, dataSourceName });
  }
}
